Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIA/diacfl.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIA/diacfl.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIA/diacfl.F90	(revision 6851)
@@ -151,12 +151,9 @@
             WRITE(numout,*) 'dia_cfl     : Maximum Courant number information for the run:'
             WRITE(numout,*) '~~~~~~~~~~~~'
-            WRITE(numout,FMT='(12x,a12,7x,f6.4,5x,a16,i4,1x,i4,1x,i4,a1)') 'Run Max Cu', cu_max,   &
-               &                                                           'at (i,j,k) = (', cu_loc(1), cu_loc(2), cu_loc(3), ')'
+            WRITE(numout,FMT='(12x,a12,7x,f6.4,5x,a16,i4,1x,i4,1x,i4,a1)') 'Run Max Cu', cu_max, 'at (i, j, k) = (', cu_loc(1), cu_loc(2), cu_loc(3), ')'
             WRITE(numout,FMT='(12x,a8,11x,f7.1)') ' => dt/C', dt*(1.0/cu_max)
-            WRITE(numout,FMT='(12x,a12,7x,f6.4,5x,a16,i4,1x,i4,1x,i4,a1)') 'Run Max Cv', cv_max,   &
-               &                                                           'at (i,j,k) = (', cv_loc(1), cv_loc(2), cv_loc(3), ')'
+            WRITE(numout,FMT='(12x,a12,7x,f6.4,5x,a16,i4,1x,i4,1x,i4,a1)') 'Run Max Cv', cv_max, 'at (i, j, k) = (', cv_loc(1), cv_loc(2), cv_loc(3), ')'
             WRITE(numout,FMT='(12x,a8,11x,f7.1)') ' => dt/C', dt*(1.0/cv_max)
-            WRITE(numout,FMT='(12x,a12,7x,f6.4,5x,a16,i4,1x,i4,1x,i4,a1)') 'Run Max Cw', cw_max,   &
-               &                                                           'at (i,j,k) = (', cw_loc(1), cw_loc(2), cw_loc(3), ')'
+            WRITE(numout,FMT='(12x,a12,7x,f6.4,5x,a16,i4,1x,i4,1x,i4,a1)') 'Run Max Cw', cw_max, 'at (i, j, k) = (', cw_loc(1), cw_loc(2), cw_loc(3), ')'
             WRITE(numout,FMT='(12x,a8,11x,f7.1)') ' => dt/C', dt*(1.0/cw_max)
 
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 6851)
@@ -118,19 +118,17 @@
       !! ** Method  :  use iom_put
       !!----------------------------------------------------------------------
-      !!
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
-      !!
-      INTEGER                      ::   ji, jj, jk              ! dummy loop indices
-      INTEGER                      ::   jkbot                   !
-      REAL(wp)                     ::   zztmp, zztmpx, zztmpy   ! 
-      !!
-      REAL(wp), POINTER, DIMENSION(:,:)   :: z2d      ! 2D workspace
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: z3d      ! 3D workspace
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      !
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   jkbot        ! local integer
+      REAL(wp) ::   zztmp, zztmpx, zztmpy   ! local scalars
+      REAL(wp), POINTER, DIMENSION(:,:)   ::   z2d   ! 2D workspace
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   z3d   ! 3D     -
       !!----------------------------------------------------------------------
       ! 
       IF( nn_timing == 1 )   CALL timing_start('dia_wri')
       ! 
-      CALL wrk_alloc( jpi , jpj      , z2d )
-      CALL wrk_alloc( jpi , jpj, jpk , z3d )
+      CALL wrk_alloc( jpi,jpj,       z2d )
+      CALL wrk_alloc( jpi,jpj,jpk,   z3d )
       !
       ! Output the initial state and forcings
@@ -140,13 +138,17 @@
       ENDIF
 
-      IF( ln_linssh ) THEN
-         CALL iom_put( "e3t" , e3t_n(:,:,:) )
-         CALL iom_put( "e3u" , e3u_n(:,:,:) )
-         CALL iom_put( "e3v" , e3v_n(:,:,:) )
-         CALL iom_put( "e3w" , e3w_n(:,:,:) )
-      ENDIF
+      ! Output of initial vertical scale factor
+      CALL iom_put("e3t_0", e3t_0(:,:,:) )
+      CALL iom_put("e3u_0", e3t_0(:,:,:) )
+      CALL iom_put("e3v_0", e3t_0(:,:,:) )
+      !
+      CALL iom_put( "e3t" , e3t_n(:,:,:) )
+      CALL iom_put( "e3u" , e3u_n(:,:,:) )
+      CALL iom_put( "e3v" , e3v_n(:,:,:) )
+      CALL iom_put( "e3w" , e3w_n(:,:,:) )
+      IF( iom_use("e3tdef") )   &
+         CALL iom_put( "e3tdef"  , ( ( e3t_n(:,:,:) - e3t_0(:,:,:) ) / e3t_0(:,:,:) * 100 * tmask(:,:,:) ) ** 2 )
 
       CALL iom_put( "ssh" , sshn )                 ! sea surface height
-      if( iom_use('ssh2') )   CALL iom_put( "ssh2", sshn(:,:) * sshn(:,:) )   ! square of sea surface height
       
       CALL iom_put( "toce", tsn(:,:,:,jp_tem) )    ! 3D temperature
@@ -184,6 +186,6 @@
                z2d(ji,jj) = rau0 * SQRT( zztmpx * zztmpx + zztmpy * zztmpy ) * tmask(ji,jj,1) 
                !
-            ENDDO
-         ENDDO
+            END DO
+         END DO
          CALL lbc_lnk( z2d, 'T', 1. )
          CALL iom_put( "taubot", z2d )           
@@ -228,4 +230,7 @@
       CALL iom_put( "avm" , avmu                       )    ! T vert. eddy visc. coef.
       CALL iom_put( "avs" , fsavs(:,:,:)               )    ! S vert. eddy diff. coef. (useful only with key_zdfddm)
+
+      IF( iom_use('logavt') )   CALL iom_put( "logavt", LOG( MAX( 1.e-20_wp, avt  (:,:,:) ) ) )
+      IF( iom_use('logavs') )   CALL iom_put( "logavs", LOG( MAX( 1.e-20_wp, fsavs(:,:,:) ) ) )
 
       IF ( iom_use("sstgrad") .OR. iom_use("sstgrad2") ) THEN
@@ -275,26 +280,22 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zztmp   = 1._wp / ( e1e2t(ji,jj) * e3t_n(ji,jj,jk) )
-                  zztmpx  = 0.5 * (  un(ji-1,jj,jk) * un(ji-1,jj,jk) * e2u(ji-1,jj) * e3u_n(ji-1,jj,jk)    &
-                     &             + un(ji  ,jj,jk) * un(ji  ,jj,jk) * e2u(ji  ,jj) * e3u_n(ji  ,jj,jk) )  &
-                     &          *  zztmp 
-                  !
-                  zztmpy  = 0.5 * (  vn(ji,jj-1,jk) * vn(ji,jj-1,jk) * e1v(ji,jj-1) * e3v_n(ji,jj-1,jk)    &
-                     &             + vn(ji,jj  ,jk) * vn(ji,jj  ,jk) * e1v(ji,jj  ) * e3v_n(ji,jj  ,jk) )  &
-                     &          *  zztmp 
-                  !
-                  rke(ji,jj,jk) = 0.5_wp * ( zztmpx + zztmpy )
-                  !
-               ENDDO
-            ENDDO
-         ENDDO
+                  zztmpx  = un(ji-1,jj,jk) * un(ji-1,jj,jk) * e1e2u(ji-1,jj) * e3u_n(ji-1,jj,jk)   &
+                     &    + un(ji  ,jj,jk) * un(ji  ,jj,jk) * e1e2u(ji  ,jj) * e3u_n(ji  ,jj,jk) 
+                  zztmpy  = vn(ji,jj-1,jk) * vn(ji,jj-1,jk) * e1e2v(ji,jj-1) * e3v_n(ji,jj-1,jk)   &
+                     &    + vn(ji,jj  ,jk) * vn(ji,jj  ,jk) * e1e2v(ji,jj  ) * e3v_n(ji,jj  ,jk)                  !
+                  rke(ji,jj,jk) = 0.25_wp * ( zztmpx + zztmpy ) * r1_e1e2t(ji,jj) / e3t_n(ji,jj,jk)
+               END DO
+            END DO
+         END DO
          CALL lbc_lnk( rke, 'T', 1. )
          CALL iom_put( "eken", rke )           
       ENDIF
-         
+      !
+      CALL iom_put( "hdiv", hdivn )                  ! Horizontal divergence
+      !
       IF( iom_use("u_masstr") .OR. iom_use("u_heattr") .OR. iom_use("u_salttr") ) THEN
-         z3d(:,:,jpk) = 0.e0
+         z3d(:,:,jpk) = 0._wp
          DO jk = 1, jpkm1
-            z3d(:,:,jk) = rau0 * un(:,:,jk) * e2u(:,:) * e3u_n(:,:,jk) * umask(:,:,jk)
+            z3d(:,:,jk) = rau0 * e2u(:,:) * e3u_n(:,:,jk) * un(:,:,jk)
          END DO
          CALL iom_put( "u_masstr", z3d )                  ! mass transport in i-direction
@@ -302,5 +303,5 @@
       
       IF( iom_use("u_heattr") ) THEN
-         z2d(:,:) = 0.e0 
+         z2d(:,:) = 0._wp
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
@@ -315,5 +316,5 @@
 
       IF( iom_use("u_salttr") ) THEN
-         z2d(:,:) = 0.e0 
+         z2d(:,:) = 0._wp
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
@@ -331,5 +332,5 @@
          z3d(:,:,jpk) = 0.e0
          DO jk = 1, jpkm1
-            z3d(:,:,jk) = rau0 * vn(:,:,jk) * e1v(:,:) * e3v_n(:,:,jk) * vmask(:,:,jk)
+            z3d(:,:,jk) = rau0 * e1v(:,:) * e3v_n(:,:,jk) * vn(:,:,jk)
          END DO
          CALL iom_put( "v_masstr", z3d )                  ! mass transport in j-direction
@@ -362,16 +363,10 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi , jpj      , z2d )
-      CALL wrk_dealloc( jpi , jpj, jpk , z3d )
-      !
-      ! If we want tmb values 
-
-      IF (ln_diatmb) THEN
-         CALL dia_tmb 
-      ENDIF 
-      IF (ln_dia25h) THEN
-         CALL dia_25h( kt )
-      ENDIF 
-
+      CALL wrk_dealloc( jpi,jpj    ,   z2d )
+      CALL wrk_dealloc( jpi,jpj,jpk,   z3d )
+      !
+      IF( ln_diatmb )   CALL dia_tmb            ! Top, Middle, Bottom diagnostics
+      IF( ln_dia25h )   CALL dia_25h( kt )      ! 25h time-mean diagnostics
+      !
       IF( nn_timing == 1 )   CALL timing_stop('dia_wri')
       !
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIU/cool_skin.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIU/cool_skin.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DIU/cool_skin.F90	(revision 6851)
@@ -17,4 +17,5 @@
    USE in_out_manager
    USE sbc_oce
+   USE lib_mpp
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    
@@ -55,13 +56,11 @@
       !! 
       !!----------------------------------------------------------------------
-      
-      IMPLICIT NONE
-      
       ALLOCATE( x_csdsst(jpi,jpj), x_csthick(jpi,jpj) )
-      x_csdsst = 0.
-      x_csthick = 0.
-      
+      x_csdsst  = 0._wp
+      x_csthick = 0._wp
+      !      
    END SUBROUTINE diurnal_sst_coolskin_init
- 
+
+
    SUBROUTINE diurnal_sst_coolskin_step(psqflux, pstauflux, psrho, rdt)
       !!----------------------------------------------------------------------
@@ -74,23 +73,16 @@
       !! ** Reference : 
       !!----------------------------------------------------------------------
-     
-      IMPLICIT NONE
-     
-      ! Dummy variables
-      REAL(wp), INTENT(IN), DIMENSION(jpi,jpj) :: psqflux     ! Heat (non-solar)(Watts)
-      REAL(wp), INTENT(IN), DIMENSION(jpi,jpj) :: pstauflux   ! Wind stress (kg/ m s^2)
-      REAL(wp), INTENT(IN), DIMENSION(jpi,jpj) :: psrho       ! Water density (kg/m^3)
-      REAL(wp), INTENT(IN) :: rdt                             ! Time-step
-     
-      ! Local variables
-      REAL(wp), DIMENSION(jpi,jpj) :: z_fv                    ! Friction velocity     
-      REAL(wp), DIMENSION(jpi,jpj) :: z_gamma                 ! Dimensionless function of wind speed
-      REAL(wp), DIMENSION(jpi,jpj) :: z_lamda                 ! Sauders (dimensionless) proportionality constant
-      REAL(wp), DIMENSION(jpi,jpj) :: z_wspd                  ! Wind speed (m/s)
-      REAL(wp) :: z_ztx                                       ! Temporary u wind stress
-      REAL(wp) :: z_zty                                       ! Temporary v wind stress
-      REAL(wp) :: z_zmod                                      ! Temporary total wind stress
-     
-      INTEGER :: ji,jj
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   psqflux     ! Heat (non-solar)(Watts)
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   pstauflux   ! Wind stress (kg/ m s^2)
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   psrho       ! Water density (kg/m^3)
+      REAL(wp)                    , INTENT(in) ::   rdt         ! Time-step
+      !
+      INTEGER  ::   ji, jj                 ! dummy loop indices
+      REAL(wp) ::   z_ztx, z_zty, z_zmod   ! local scalar
+      REAL(wp), DIMENSION(jpi,jpj) ::   z_fv      ! Friction velocity     
+      REAL(wp), DIMENSION(jpi,jpj) ::   z_gamma   ! Dimensionless function of wind speed
+      REAL(wp), DIMENSION(jpi,jpj) ::   z_lamda   ! Sauders (dimensionless) proportionality constant
+      REAL(wp), DIMENSION(jpi,jpj) ::   z_wspd    ! Wind speed (m/s)
+      !!----------------------------------------------------------------------
      
       IF ( .NOT. ln_blk_core ) THEN
@@ -107,8 +99,7 @@
                z_wspd(ji,jj) = SQRT( pstauflux(ji,jj) / ( pp_cda * pp_rhoa ) )
             ELSE
-               z_fv(ji,jj) = 0.
-               z_wspd(ji,jj) = 0.     
+               z_fv  (ji,jj) = 0._wp
+               z_wspd(ji,jj) = 0._wp
             ENDIF
-
  
             ! Calculate gamma function which is dependent upon wind speed
@@ -119,5 +110,4 @@
             ENDIF
 
-
             ! Calculate lamda function
             IF( tmask(ji,jj,1) == 1. .AND. z_fv(ji,jj) /= 0 ) THEN
@@ -126,6 +116,4 @@
                z_lamda(ji,jj) = 0.
             ENDIF
-
-
 
             ! Calculate the cool skin thickness - only when heat flux is out of the ocean
@@ -136,6 +124,4 @@
             ENDIF
 
-
-
             ! Calculate the cool skin correction - only when the heat flux is out of the ocean
             IF( tmask(ji,jj,1) == 1. .AND. x_csthick(ji,jj) /= 0. .AND. psqflux(ji,jj) < 0. ) THEN
@@ -144,10 +130,10 @@
                x_csdsst(ji,jj) = 0.
             ENDIF
-
-         ENDDO
-      ENDDO
-
+            !
+         END DO
+      END DO
+      !
    END SUBROUTINE diurnal_sst_coolskin_step
 
-
+   !!=====================================================================
 END MODULE cool_skin
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 6851)
@@ -653,14 +653,4 @@
          ht_n(:,:) = ht_n(:,:) + e3t_n(:,:,jk) * tmask(:,:,jk)
       END DO
-
-      ! Write outputs
-      ! =============
-      CALL iom_put(     "e3t",   e3t_n(:,:,:) )
-      CALL iom_put(     "e3u",   e3u_n(:,:,:) )
-      CALL iom_put(     "e3v",   e3v_n(:,:,:) )
-      CALL iom_put(     "e3w",   e3w_n(:,:,:) )
-      CALL iom_put( "tpt_dep", gde3w_n(:,:,:) )
-      IF( iom_use("e3tdef") )   &
-         CALL iom_put( "e3tdef", ( ( e3t_n(:,:,:) - e3t_0(:,:,:) ) / e3t_0(:,:,:) * 100. * tmask(:,:,:) ) ** 2 )
 
       ! write restart file
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 6851)
@@ -71,13 +71,13 @@
       !
       !                                                         ! horizontal mesh (inum3)
-      CALL iom_rstput( 0, 0, inum0, 'glamt', glamt, ktype = jp_r4 )     !    ! latitude
-      CALL iom_rstput( 0, 0, inum0, 'glamu', glamu, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum0, 'glamv', glamv, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum0, 'glamf', glamf, ktype = jp_r4 )
-      
-      CALL iom_rstput( 0, 0, inum0, 'gphit', gphit, ktype = jp_r4 )     !    ! longitude
-      CALL iom_rstput( 0, 0, inum0, 'gphiu', gphiu, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum0, 'gphiv', gphiv, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum0, 'gphif', gphif, ktype = jp_r4 )
+      CALL iom_rstput( 0, 0, inum0, 'glamt', glamt, ktype = jp_r8 )     !    ! latitude
+      CALL iom_rstput( 0, 0, inum0, 'glamu', glamu, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum0, 'glamv', glamv, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum0, 'glamf', glamf, ktype = jp_r8 )
+      
+      CALL iom_rstput( 0, 0, inum0, 'gphit', gphit, ktype = jp_r8 )     !    ! longitude
+      CALL iom_rstput( 0, 0, inum0, 'gphiu', gphiu, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum0, 'gphiv', gphiv, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum0, 'gphif', gphif, ktype = jp_r8 )
       
       CALL iom_rstput( 0, 0, inum0, 'e1t', e1t, ktype = jp_r8 )         !    ! e1 scale factors
@@ -129,5 +129,4 @@
       !!                                   masks, depth and vertical scale factors
       !!----------------------------------------------------------------------
-      !!
       INTEGER           ::   inum0    ! temprary units for 'mesh_mask.nc' file
       INTEGER           ::   inum1    ! temprary units for 'mesh.nc'      file
@@ -229,13 +228,13 @@
 
       !                                                         ! horizontal mesh (inum3)
-      CALL iom_rstput( 0, 0, inum3, 'glamt', glamt, ktype = jp_r4 )     !    ! latitude
-      CALL iom_rstput( 0, 0, inum3, 'glamu', glamu, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum3, 'glamv', glamv, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum3, 'glamf', glamf, ktype = jp_r4 )
-      
-      CALL iom_rstput( 0, 0, inum3, 'gphit', gphit, ktype = jp_r4 )     !    ! longitude
-      CALL iom_rstput( 0, 0, inum3, 'gphiu', gphiu, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum3, 'gphiv', gphiv, ktype = jp_r4 )
-      CALL iom_rstput( 0, 0, inum3, 'gphif', gphif, ktype = jp_r4 )
+      CALL iom_rstput( 0, 0, inum3, 'glamt', glamt, ktype = jp_r8 )     !    ! latitude
+      CALL iom_rstput( 0, 0, inum3, 'glamu', glamu, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum3, 'glamv', glamv, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum3, 'glamf', glamf, ktype = jp_r8 )
+      
+      CALL iom_rstput( 0, 0, inum3, 'gphit', gphit, ktype = jp_r8 )     !    ! longitude
+      CALL iom_rstput( 0, 0, inum3, 'gphiu', gphiu, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum3, 'gphiv', gphiv, ktype = jp_r8 )
+      CALL iom_rstput( 0, 0, inum3, 'gphif', gphif, ktype = jp_r8 )
       
       CALL iom_rstput( 0, 0, inum3, 'e1t', e1t, ktype = jp_r8 )         !    ! e1 scale factors
@@ -257,5 +256,5 @@
       CALL iom_rstput( 0, 0, inum4, 'misf', zprt, ktype = jp_i2 )       !    ! nb of ocean T-points
       zprt(:,:) = ssmask(:,:) * REAL( risfdep(:,:) , wp )
-      CALL iom_rstput( 0, 0, inum4, 'isfdraft', zprt, ktype = jp_r4 )       !    ! nb of ocean T-points
+      CALL iom_rstput( 0, 0, inum4, 'isfdraft', zprt, ktype = jp_r8 )       !    ! nb of ocean T-points
             
       IF( ln_sco ) THEN                                         ! s-coordinate
@@ -279,6 +278,6 @@
          CALL iom_rstput( 0, 0, inum4, 'gdept_1d' , gdept_1d )  !    ! stretched system
          CALL iom_rstput( 0, 0, inum4, 'gdepw_1d' , gdepw_1d )
-         CALL iom_rstput( 0, 0, inum4, 'gdept_0', gdept_0, ktype = jp_r4 )     
-         CALL iom_rstput( 0, 0, inum4, 'gdepw_0', gdepw_0, ktype = jp_r4 )
+         CALL iom_rstput( 0, 0, inum4, 'gdept_0', gdept_0, ktype = jp_r8 )     
+         CALL iom_rstput( 0, 0, inum4, 'gdepw_0', gdepw_0, ktype = jp_r8 )
       ENDIF
       
@@ -302,5 +301,5 @@
          !
          IF( nmsh <= 3 ) THEN                                   !    ! 3D depth
-            CALL iom_rstput( 0, 0, inum4, 'gdept_0', gdept_0, ktype = jp_r4 )     
+            CALL iom_rstput( 0, 0, inum4, 'gdept_0', gdept_0, ktype = jp_r8 )     
             DO jk = 1,jpk   
                DO jj = 1, jpjm1   
@@ -312,7 +311,7 @@
             END DO
             CALL lbc_lnk( zdepu, 'U', 1. )   ;   CALL lbc_lnk( zdepv, 'V', 1. ) 
-            CALL iom_rstput( 0, 0, inum4, 'gdepu', zdepu, ktype = jp_r4 )
-            CALL iom_rstput( 0, 0, inum4, 'gdepv', zdepv, ktype = jp_r4 )
-            CALL iom_rstput( 0, 0, inum4, 'gdepw_0', gdepw_0, ktype = jp_r4 )
+            CALL iom_rstput( 0, 0, inum4, 'gdepu', zdepu, ktype = jp_r8 )
+            CALL iom_rstput( 0, 0, inum4, 'gdepv', zdepv, ktype = jp_r8 )
+            CALL iom_rstput( 0, 0, inum4, 'gdepw_0', gdepw_0, ktype = jp_r8 )
          ELSE                                                   !    ! 2D bottom depth
             DO jj = 1,jpj   
@@ -322,6 +321,6 @@
                END DO
             END DO
-            CALL iom_rstput( 0, 0, inum4, 'hdept', zprt, ktype = jp_r4 )     
-            CALL iom_rstput( 0, 0, inum4, 'hdepw', zprw, ktype = jp_r4 ) 
+            CALL iom_rstput( 0, 0, inum4, 'hdept', zprt, ktype = jp_r8 )     
+            CALL iom_rstput( 0, 0, inum4, 'hdepw', zprw, ktype = jp_r8 ) 
          ENDIF
          !
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 6851)
@@ -137,4 +137,9 @@
       IF( ln_sco      )   ioptio = ioptio + 1
       IF( ioptio /= 1 )   CALL ctl_stop( ' none or several vertical coordinate options used' )
+      !
+      ioptio = 0
+      IF ( ln_zco .AND. ln_isfcav )   ioptio = ioptio + 1
+      IF ( ln_sco .AND. ln_isfcav )   ioptio = ioptio + 1
+      IF( ioptio > 0 )   CALL ctl_stop( ' Cavity not tested/compatible with full step (zco) and sigma (ln_sco) ' )
       !
       ! Build the vertical coordinate system
@@ -503,4 +508,6 @@
             CALL iom_close( inum )
             mbathy(:,:) = INT( bathy(:,:) )
+            ! initialisation isf variables
+            risfdep(:,:) = 0._wp   ;   misfdep(:,:) = 1             
             !                                                ! =====================
             IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN    ! ORCA R2 configuration
@@ -539,6 +546,7 @@
             CALL iom_close( inum )
             !                                                
-            risfdep(:,:)=0._wp         
-            misfdep(:,:)=1             
+            ! initialisation isf variables
+            risfdep(:,:) = 0._wp   ;   misfdep(:,:) = 1             
+            !
             IF ( ln_isfcav ) THEN
                CALL iom_open ( 'isf_draft_meter.nc', inum ) 
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90	(revision 6851)
@@ -118,6 +118,6 @@
       ENDIF
       DO jk = 2, jpkm1                    ! interior advective fluxes
-         DO jj = 2, jpjm1                       ! 1/4 * Vertical transport
-            DO ji = fs_2, fs_jpim1
+         DO jj = 2, jpj                         ! 1/4 * Vertical transport
+            DO ji = fs_2, jpi
                zfw(ji,jj,jk) = 0.25_wp * e1e2t(ji,jj) * wn(ji,jj,jk)
             END DO
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90	(revision 6851)
@@ -211,6 +211,6 @@
       ENDIF
       DO jk = 2, jpkm1                          ! interior fluxes
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
+         DO jj = 2, jpj
+            DO ji = fs_2, jpi
                zfw(ji,jj,jk) = 0.25_wp * e1e2t(ji,jj) * wn(ji,jj,jk)
             END DO
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 6851)
@@ -294,5 +294,5 @@
             ze3va =  ( 1._wp - r_vvl ) * e3v_n(ji,jj,1) + r_vvl * e3v_a(ji,jj,1) 
             va(ji,jj,1) = va(ji,jj,1) + p2dt * 0.5_wp * ( vtau_b(ji,jj) + vtau(ji,jj) )   &
-               &                                      / ( ze3va * rau0 ) 
+               &                                      / ( ze3va * rau0 ) * vmask(ji,jj,1) 
          END DO
       END DO
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ICB/icbini.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ICB/icbini.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ICB/icbini.F90	(revision 6851)
@@ -120,5 +120,5 @@
       ! first entry with narea for this processor is left hand interior index
       ! last  entry                               is right hand interior index
-      jj = jpj/2
+      jj = nlcj/2
       nicbdi = -1
       nicbei = -1
@@ -136,5 +136,5 @@
       !
       ! repeat for j direction
-      ji = jpi/2
+      ji = nlci/2
       nicbdj = -1
       nicbej = -1
@@ -153,9 +153,9 @@
       ! special for east-west boundary exchange we save the destination index
       i1 = MAX( nicbdi-1, 1)
-      i3 = INT( src_calving(i1,jpj/2) )
+      i3 = INT( src_calving(i1,nlcj/2) )
       jj = INT( i3/nicbpack )
       ricb_left = REAL( i3 - nicbpack*jj, wp )
       i1 = MIN( nicbei+1, jpi )
-      i3 = INT( src_calving(i1,jpj/2) )
+      i3 = INT( src_calving(i1,nlcj/2) )
       jj = INT( i3/nicbpack )
       ricb_right = REAL( i3 - nicbpack*jj, wp )
@@ -196,5 +196,5 @@
          WRITE(numicb,*) 'berg left       ', ricb_left
          WRITE(numicb,*) 'berg right      ', ricb_right
-         jj = jpj/2
+         jj = nlcj/2
          WRITE(numicb,*) "central j line:"
          WRITE(numicb,*) "i processor"
@@ -202,5 +202,5 @@
          WRITE(numicb,*) "i point"
          WRITE(numicb,*) (INT(src_calving(ji,jj)), ji=1,jpi)
-         ji = jpi/2
+         ji = nlci/2
          WRITE(numicb,*) "central i line:"
          WRITE(numicb,*) "j processor"
Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 6851)
@@ -114,5 +114,5 @@
       CASE (30)   ;   CALL xios_set_context_attr(TRIM(clname), calendar_type= "D360")
       END SELECT
-      WRITE(cldate,"(i4.4,'-',i2.2,'-',i2.2,' 00:00:00')") nyear,nmonth,nday 
+      WRITE(cldate,"(i4.4,'-',i2.2,'-',i2.2,' ',i2.2,':',i2.2,':00')") nyear,nmonth,nday,nhour,nminute
       CALL xios_set_context_attr(TRIM(clname), start_date=cldate )
 
@@ -792,7 +792,7 @@
                   ENDIF
                   IF( PRESENT(pv_r3d) ) THEN
-                     IF( idom == jpdom_data ) THEN                         ;   icnt(3) = jpkdta
+                     IF( idom == jpdom_data ) THEN                         ;   icnt  (3) = jpkdta
                      ELSE IF( ll_depth_spec .AND. PRESENT(kstart) ) THEN   ;   istart(3) = kstart(3)   ;   icnt(3) = kcount(3)
-                     ELSE                                                  ;   icnt(3) = jpk
+                     ELSE                                                  ;   icnt  (3) = jpk
                      ENDIF
                   ENDIF
